﻿local dataobject = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_Speed", {
	type = "data source",
	icon = "Interface\\Icons\\Ability_Rogue_Sprint.blp",
	label = "Speed",
	suffix = "%",
	value = 0,
})
local horiz_dataobject = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_Speed_Horizontal", {
	type = "data source",
	icon = "Interface\\Icons\\Ability_Rogue_Sprint.blp",
	label = "Horizontal Speed",
	suffix = "%",
	value = 0,
})

local floor = math.floor
local format = string.format
local cos = math.cos
local GetUnitSpeed = GetUnitSpeed
local GetUnitPitch = GetUnitPitch
local speed, pitch
local function UpdateSpeed(frame,elapsed)
	local newspeed = GetUnitSpeed("player")
	local newpitch = GetUnitPitch("player")
	if newspeed == speed and (not (IsMounted() or IsSwimming()) or newpitch == pitch) then return end
	speed = newspeed
	pitch = newpitch

	local horiz_too = true
	local icon = "Interface\\Icons\\Ability_Rogue_Sprint"
	if UnitOnTaxi("player") then
		icon = "Interface\\CURSOR\\Taxi"
	elseif IsSwimming() then
		icon = "Interface\\Icons\\Ability_Druid_AquaticForm"
		horiz_too = false
	elseif IsFlying() then
		icon = "Interface\\Icons\\Ability_Druid_FlightForm"
		horiz_too = false
	elseif IsFalling() then
		icon = "Interface\\Icons\\Spell_Magic_FeatherFall"
	elseif IsMounted() then
		icon = "Interface\\Icons\\Ability_Mount_RidingHorse"
	end
	dataobject.icon = icon
	horiz_dataobject.icon = icon
	dataobject.value = floor(speed / 7 * 100 + 0.1)
	dataobject.text = dataobject.value .. dataobject.suffix
	if IsSwimming() or IsFlying() then
		-- pitch is in radians; 0 == perfectly horizontal; + for up, - for down
		
		horiz_dataobject.value = floor(speed * cos(pitch) / 7 * 100 + 0.1)
		horiz_dataobject.text = horiz_dataobject.value .. horiz_dataobject.suffix
	else
		pitch = nil
		horiz_dataobject.value = dataobject.value
		horiz_dataobject.text = dataobject.text
	end
end

local frame = CreateFrame("Frame")
frame:SetScript("OnUpdate", UpdateSpeed)

